;																		
;																		
; Dieses Assembler-Programm	generiert ein VGA-SIGNAL					
;																		
;																		
; 640x480 - 60HZ 														
; 																		
; 164x120 PIXEL															
;																		
; ATmega1284P-20MHz														
;																		
; AVR-STUDIO 4															
; Bernhard.Erfurt@gmx.de												
; VERSION: 1 (06/2015)													
;																		

;																		
; GRN leuchtet: alle-ok und alles schn								
; GELB leuchtet:														
; ROT  leuchtet: die automatische Taktkorrektur im Interrupt versagt	
; ROT+GELB leuchtet: Zeilennummern stimmen nicht 						

;																		
; Blinken die LEDs, das ist nicht gut !									
; ROT blinkt: 				Fehler im Programmcheck						
; ROT+GELB blinken: 		WDR-Zeitberschreitung						
; ROT+GELB+GRN blinken: 	unkorrekter Interruptaufruf					
;																		

;																		
; Die Pixel generiert der PORT-B, ist aber	dadurch komplett belegt		
;																		


;												
; Anschlussbelegung PINS						
;												
; PA0 ==> 										
; PA1 ==> 										
; PA2 ==> 										
; PA3 ==> 										
; PA4 ==> 										
; PA5 ==> 										
; PA6 ==> 										
; PA7 ==> 										
;												
; PB0 ==> ROT									
; PB1 ==> GRN									
; PB2 ==> BLAU									
; PB3 ==>										
; PB4 ==> 										
; PB5 ==> 										
; PB6 ==> 										
; PB7 ==> 										
;												
; PC0 ==> 										
; PC1 ==> 										
; PC2 ==> 										
; PC3 ==> 										
; PC4 ==> 										
; PC5 ==> 										
; PC6 ==> 										
; PC7 ==> TEST-AUSGANG							
;												
; PD0 ==> VSYNC									
; PD1 ==> HSYNC									
; PD2 ==> 										
; PD3 ==> 										
; PD4 ==> LED GRN								
; PD5 ==> LED GELB								
; PD6 ==> LED ROT								
; PD7 ==> 										
;												

; ATmega1284P 									
.include "m1284pdef.inc"
; KONSTANTEN									
.equ TAKT									= 20000000	; 20 MHz		
; TIMER-WERTE									
.equ TIMER1_CTC_FREQUENZ					= 31496/2
.equ TIMER1_N								= 1
.equ TIMER1_CTC								=(TAKT/(2*TIMER1_N*TIMER1_CTC_FREQUENZ))-1
; TEST-PIN										
.equ TEST_PIN_NR							= 7
.equ TEST_DDR								= DDRC
.equ TEST_PORT								= PORTC
; VGA-RGB-DATA-PORT								
.equ RGB_DATA_DDR							= DDRB
.equ RGB_DATA_PORT							= PORTB
; VGA-ROT-GRN-BLAU								
.equ R_DATA_PIN_NR							= 0
.equ G_DATA_PIN_NR							= 1
.equ B_DATA_PIN_NR							= 2
; VGA-V-SYNCHRON(BILDANFANG)					
.equ VSYNC_PIN_NR							= 0
.equ VSYNC_DDR								= DDRD
.equ VSYNC_PORT								= PORTD
; VGA-H-SYNCHRON (ZEILE)						
.equ HSYNC_PIN_NR							= 1
.equ HSYNC_DDR								= DDRD
.equ HSYNC_PORT								= PORTD
; LED-GRUEN										
.equ LED_GRUEN_PIN_NR						= 4
.equ LED_GRUEN_DDR							= DDRD
.equ LED_GRUEN_PORT							= PORTD
; LED-GELB										
.equ LED_GELB_PIN_NR						= 5
.equ LED_GELB_DDR							= DDRD
.equ LED_GELB_PORT							= PORTD
; LED-ROT										
.equ LED_ROT_PIN_NR							= 6
.equ LED_ROT_DDR							= DDRD
.equ LED_ROT_PORT							= PORTD
; REGISTER												
.def HILFSREGISTER_R0=R0	; wichtiges Rechenregister	
.def HILFSREGISTER_R1=R1	; wichtiges Rechenregister	
.def HILFSREGISTER_R2=R2	; wichtiges Rechenregister	
.def HILFSREGISTER_R3=R3	; wichtiges Rechenregister	
.def HILFSREGISTER_R4=R4	; wichtiges Rechenregister	
.def HILFSREGISTER_R5=R5	; wichtiges Rechenregister	
.def HILFSREGISTER_R6=R6	; wichtiges Rechenregister	
.def HILFSREGISTER_R7=R7	; wichtiges Rechenregister	
.def SREG_KOPIE		= R8	; BILDERZEIGUNG - nutzt nur der 31s-TIMER-Interrupt !
.def temp_KOPIE		= R9	; BILDERZEIGUNG - nutzt nur der 31s-TIMER-Interrupt !
.def YL_KOPIE		= R10	; BILDERZEIGUNG - nutzt nur der 31s-TIMER-Interrupt !
.def YH_KOPIE		= R11	; BILDERZEIGUNG - nutzt nur der 31s-TIMER-Interrupt !
.def ZL_KOPIE		= R12	; BILDERZEIGUNG - nutzt nur der 31s-TIMER-Interrupt !
.def ZH_KOPIE		= R13	; BILDERZEIGUNG - nutzt nur der 31s-TIMER-Interrupt !
.def NULL 			= R14	; ist immer NULL 	
.def EINS 			= R15	; ist immer EINS 	
.def temp 			= R16
.def temp1 			= R17
.def temp2 			= R18
.def temp3 			= R19
.def temp4 			= R20
.def temp5 			= R21
.def temp6 			= R22
.def temp7 			= R23
.def temp8 			= R24
.def temp9 			= R25
; SRAM-BELEGUNG Adr:0x0100-0x40FF(256-16.639=16383)		
.equ adr_DATEN						=SRAM_START+0		

.equ adr_GRAFIC_FARBE				=SRAM_START+1100		; 0=wei 1=schwarz			
.equ adr_GRAFIC_PUNKT_GROESSE		=SRAM_START+1102		; PUNKT-GRSSE 0...9		

.equ adr_VGA_TURBO_ON				=SRAM_START+3000
.equ adr_VGA_TURBO_OFF				=SRAM_START+3001
.equ adr_VGA_BILDZEILEN_NR_L		=SRAM_START+3002		; BILD-ZEILENNUMMER					
.equ adr_VGA_BILDZEILEN_NR_H		=SRAM_START+3003
.equ adr_VGA_ZEIGER_DATA_L			=SRAM_START+3004		; ZEIGER fr BILD-DATEN				
.equ adr_VGA_ZEIGER_DATA_H			=SRAM_START+3005
.equ adr_VGA_PIXEL_ZEILEN_COUNTER	=SRAM_START+3006		; PIXELZEILE						
.equ adr_VGA_BILD_ZEILE				=SRAM_START+3007
.equ adr_VGA_DUMMY					=SRAM_START+3008
.equ adr_VGA_TURBO_BEREICH120		=SRAM_START+3010

.equ adr_VGA_BILDBEREICH			=SRAM_START+4006		; BILDSPEICHER						
.equ adr_VGA_BILDBEREICH_ENDE		=SRAM_START+4006+9840	;(164x120/2=9.840 Bytes)			

.equ adr_SRAM_CHECK					=SRAM_START+15500		; SRAM CHECK muss immer "S" sein	


;---------------------------------------------------------------------------
.cseg							;Beginn eines Code-Segmentes				
.org 0							;Startadresse=0								
.org 0x0000 rjmp RESET 			 ; Reset									
.org 0x0002 rjmp INTERRUPT_ERROR ;rjmp INT0 ; IRQ0							
.org 0x0004 rjmp INTERRUPT_ERROR ;rjmp INT1 ; IRQ1							
.org 0x0006 rjmp INTERRUPT_ERROR ;rjmp INT2 ; IRQ2							
.org 0x0008 rjmp INTERRUPT_ERROR ;rjmp PCINT0 ; PCINT0						
.org 0x000A rjmp INTERRUPT_ERROR ;rjmp PCINT1 ; PCINT1						
.org 0x000C rjmp INTERRUPT_ERROR ;rjmp PCINT2 ; PCINT2						
.org 0x000E rjmp INTERRUPT_ERROR ;rjmp PCINT3 ; PCINT3						
.org 0x0010 jmp WDT 		; Watchdog Timeout								
.org 0x0012 rjmp INTERRUPT_ERROR ;rjmp TIM2_COMPA ; Timer2 CompareA			
.org 0x0014 rjmp INTERRUPT_ERROR ;rjmp TIM2_COMPB ; Timer2 CompareB			
.org 0x0016 rjmp INTERRUPT_ERROR ;rjmp TIM2_OVF 	; Timer2 Overflow		
.org 0x0018 rjmp INTERRUPT_ERROR ;rjmp TIM1_CAPT ; Timer1 Capture			
.org 0x001A rjmp TIM1_COMPA ; Timer1 CompareA				
.org 0x001C rjmp INTERRUPT_ERROR ;rjmp TIM1_COMPB ; Timer1 CompareB			
.org 0x001E rjmp INTERRUPT_ERROR ;TIM1_OVF 	; Timer1 Overflow				
.org 0x0020 rjmp INTERRUPT_ERROR ;TIM0_COMPA ; Timer0 CompareA				
.org 0x0022 rjmp INTERRUPT_ERROR ;rjmp TIM0_COMPB ; Timer0 CompareB			
.org 0x0024 rjmp INTERRUPT_ERROR ;rjmp TIM0_OVF 	; Timer0 Overflow		
.org 0x0026 rjmp INTERRUPT_ERROR ;rjmp SPI_STC ; SPI Transfer Complete		
.org 0x0028 rjmp INTERRUPT_ERROR ;rjmp USART0_RXC ; USART0 RX Complete		
.org 0x002A rjmp INTERRUPT_ERROR ;rjmp USART0_UDRE ; USART0,UDR Empty		
.org 0x002C rjmp INTERRUPT_ERROR ;rjmp USART0_TXC ; USART0 TX Complete		
.org 0x002E rjmp INTERRUPT_ERROR ;rjmp ANA_COMP ; Analog Comparator			
.org 0x0030 rjmp INTERRUPT_ERROR ;rjmp ADC ; ADC Conversion Complete		
.org 0x0032 rjmp INTERRUPT_ERROR ;rjmp EE_RDY ; EEPROM Ready				
.org 0x0034 rjmp INTERRUPT_ERROR ;rjmp TWI ; 2-wire Serial					
.org 0x0036 rjmp INTERRUPT_ERROR ;rjmp SPM_RDY ; SPM Ready					
.org 0x0038 rjmp INTERRUPT_ERROR ;rjmp USART1_RXC ; USART1 RX Complete		
.org 0x003A rjmp INTERRUPT_ERROR ;rjmp USART1_UDRE ; USART1,UDR Empty		
.org 0x003C rjmp INTERRUPT_ERROR ;rjmp USART1_TXC ; USART1 TX Complete		
.org 0x003E rjmp INTERRUPT_ERROR ;rjmp TIM3_CAPT ; Timer3 Capture			
.org 0x0040 rjmp INTERRUPT_ERROR ;rjmp TIM3_COMPA ; Timer3 CompareA			
.org 0x0042 rjmp INTERRUPT_ERROR ;rjmp TIM3_COMPB ; Timer3 CompareB			
.org 0x0044 rjmp INTERRUPT_ERROR ;rjmp TIM3_OVF 	; Timer3 Overflow		
; Unkorrekten Interrupt Aufruf 						
INTERRUPT_ERROR:
	CLI											; INTERRUPTS sperren	
	cbi (LED_GRUEN_PORT),(LED_GRUEN_PIN_NR)		; GRN an   
	cbi (LED_GELB_PORT),(LED_GELB_PIN_NR)		; GELB an	
	cbi (LED_ROT_PORT),(LED_ROT_PIN_NR)			; ROT  an	
	call wait_100ms
	sbi (LED_GRUEN_PORT),(LED_GRUEN_PIN_NR)		; GRN aus	
	sbi (LED_GELB_PORT),(LED_GELB_PIN_NR)		; GELB aus  
	sbi (LED_ROT_PORT),(LED_ROT_PIN_NR)			; ROT  aus	
	call wait_100ms
	rjmp INTERRUPT_ERROR
;-------------------------------------------------------------------------------
RESET:                        
; STACK initialisieren								
	ldi temp, LOW(RAMEND)
    out SPL, temp
    ldi temp, HIGH(RAMEND)
    out SPH, temp
; SRAM_CLEAR										
	call SRAM_CLEAR
; STARTWERTE										
	; NULL				
	clr NULL
	; EINS				
	ldi temp,1
	mov EINS,temp
	; SRAM CHECK		
	ldi temp,'S'
	STS(adr_SRAM_CHECK),temp
; PORT A+B+C+D initialisieren (alles EINGNGE+PULL-UP aus)	
	out DDRA, NULL
	out PORTA,NULL
	out DDRB, NULL
	out PORTB,NULL
	out DDRC, NULL
	out PORTC,NULL
	out DDRD, NULL
	out PORTD,NULL
; LED_INITIALISIERUNG										
	call LED_INITIALISIERUNG
; VGA_PIN_INITIALISIERUNG									
	call VGA_PIN_INITIALISIERUNG
; WDR_INITIALISIERUNG										
	call WDR_INITIALISIERUNG
; NEUSTART_MIT_WDR											
	call NEUSTART_MIT_WDR
; TIMER INITALISIERUNG										
	call TIMER1_INITIALISIERUNG_CTC
; Interrupts freigeben										
	sei
; ##############################################################################
; ##############################################################################
; ##############################################################################
; EINSCHWINGEN												
	call GRAFIC_CLEAR
	call PROGRAMM_CHECK
	call LED_TEST 								; LED_TEST		
	sbi (LED_ROT_PORT),LED_ROT_PIN_NR			; ROT  aus		
	cbi (LED_GRUEN_PORT),(LED_GRUEN_PIN_NR)		; GRN an   	
	call VGA_TEST_RAND_PIXEL
	call wait_1s
	call wait_1s
;-------------------------------------------------------------------------------
	call VGA_TEST_FARBBALKEN
	call wait_100ms
	call GRAFIC_CLEAR

	call VGA_TEST_SCHACHBRETT
	call wait_100ms
	call GRAFIC_CLEAR

	call VGA_TEST_PUNKTGROESSE
	call wait_100ms
	call GRAFIC_CLEAR

	call VGA_TEST_FARB_PIXEL
	call wait_100ms
	call GRAFIC_CLEAR

	call VGA_TEST_FARBBALKEN
;	call wait_100ms
;	call GRAFIC_CLEAR
; ##############################################################################
; ##############################################################################
; ##############################################################################
LOOP:
	WDR										; Watch-Dog-RESET	
	call PROGRAMM_CHECK
rjmp LOOP
; ##############################################################################
; ##############################################################################
; ##############################################################################
.include "VGA_BILD_MACRO.asm"				; BILDAUFBAU					
.include "VGA_BILD.asm"						; TIMER+BILDAUFBAU				
.include "VGA_GRAFIC.asm"					; GRAFIC allgemein				
.include "VGA_GRAFIC_PUNKT.asm"				; PUNKT							
.include "VGA_SONSTIGES.asm"				; sonstiges						
.include "VGA_GRAFIC_TESTS.asm"				; TESTBILDER					
.include "VGA_WAIT_20MHZ.asm"				; 20 MHz						


